// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

const VERSION		= "0.5.2";
const DISPLAY_NAME	= "Gmail Manager";
const ID			= "{582195F5-92E7-40a0-A127-DB71295901D7}";
const NAME			= "gmanager";
const KEY			= "/gmanager";
const JAR_FILE		= NAME + ".jar";
const COMPONENTS	= ["gmCookies", "gmManager", "gmParser", "gmPrefs",
                       "gmService", "gmServiceGmail"];
const LOCALES		= ["en-US", "bg-BG", "ca-AD", "cs-CZ", "de-DE", "el-GR",
                       "es-AR", "es-ES", "fa-IR", "fi-FI", "fr-FR", "gl-ES",
                       "he-IL", "hr-HR", "it-IT", "ja-JP", "ko-KR", "lt-LT",
                       "nl-NL", "pl-PL", "pt-BR", "pt-PT", "ru-RU", "sk-SK",
                       "sl-SI", "th-TH", "tr-TR", "zh-CN", "zh-TW"];

// Begin install
initInstall(NAME, KEY, VERSION);

var mainDir = getFolder("Profile", "extensions/" + ID);
var chromeDir = getFolder(mainDir, "chrome");
var defaultsDir = getFolder(mainDir, "defaults");
var componentsDir = getFolder("Components");
var jarDir = getFolder(chromeDir, JAR_FILE);

// Chrome jar file
addFile(KEY, VERSION, "chrome/" + JAR_FILE, chromeDir, null);

// Hack to register components
addFile(KEY, VERSION, "components/.autoreg", getFolder("Program"), "");

// Defaults directory and preferences
addDirectory(KEY, VERSION, "defaults", defaultsDir, null);
defaultsDir = getFolder(getFolder("Program", "defaults"), "pref");
addFile(KEY, VERSION, "defaults/preferences/gmanager.js", defaultsDir, null);

// XPCOM components
for (var i = 0; i < COMPONENTS.length; i++) {
  addFile(KEY, VERSION, "components/" + COMPONENTS[i] + ".js", componentsDir, null);
  addFile(KEY, VERSION, "components/" + COMPONENTS[i] + ".xpt", componentsDir, null);
}

// Content and Skin
registerChrome(CONTENT | PROFILE_CHROME, jarDir, "content/");
registerChrome(SKIN | PROFILE_CHROME, jarDir, "skin/classic/");

// Locales
for (var i = 0; i < LOCALES.length; i++)
  registerChrome(LOCALE | PROFILE_CHROME, jarDir, "locale/" + LOCALES[i] + "/");

// Checks that for success so far
if (getLastError() == SUCCESS) {
  var err = performInstall();
  
  if (err == SUCCESS)
    alert(DISPLAY_NAME + " " + VERSION + " installed successfully!\n" +
          "Please restart to enable the extension.");
}
else
  cancelInstall();
